#!/usr/bin/php -q
<?php

include('/usr/php/include/provisioningTool.class.php');
require_once('/usr/local/www/berogui/includes/fileManagement.php');

$usageMessage = 'Usage: ' . $argv[0] . ' [config|firmware|show_config]' . "\n";

if (count($argv) <= 1) {
	echo $usageMessage;
	return(1);
}

if (file_exists('/usr/conf/tls/client.pem')) {
	$enddate = strtotime(exec("openssl x509 -in /usr/conf/tls/client.pem -noout -enddate | cut -d '=' -f 2"));
	if ($enddate < (time() + 30*86400)) {
		$startdate = strtotime(exec("openssl x509 -in /usr/conf/tls/client.pem -noout -startdate | cut -d '=' -f 2"));
		require_once('/usr/fallback/beroConf.php');
		$bc = new beroconf('root');
		require_once('/usr/local/php/include/berocloud/SbcApi.php');
		$cloud = new SbcApi();
		$res = $cloud->send('renewCertificate', array(
			'lifs' => implode('_', helper::getLif($bc)),
			'mac' => helper::getNetworkMacAddr(helper::getNetworkIfaceByName('lan', $bc)),
			'withTls' => (int)(($enddate - $startdate)/86400),
		));
		extract(unserialize($res));
		if (!isset($client) || $error) {
			exit(0);
		}
		file_put_contents('/usr/conf/tls/client.pem', $client);
	}
}

$pt = new provisioningTool();

for ($i = 1; $i < $argc; $i++) {
	switch ($argv[$i]) {
	case 'config':
		$ba = null;
		$save = array();
		require_once('/usr/fallback/beroConf.php');
		$bc = new beroConf('root');
		if ($bc->get('root', 'reboot-provisioning') == 'tls') {
			// connected to berocloud. save the cloud connection
			require_once('/usr/local/www/berogui/misc/database.php');
			$ba = new beroAri();
			foreach (array('cloud_enable', 'cloud_key') as $key) {
				$save['bc'][$key] = $bc->get('root', $key);
			}
			foreach (array('cloudAddress', 'cloud_show_status') as $key) {
				$save['ba'][$key] = $ba->get($key);
			}
		}
		$ret = ($pt->updateConfig() == true) ? 0 : 1;
		$pt->updateAppConfig();
		if (!empty($save)) {
			// connected to berocloud. restore the cloud connection
			foreach ($save['bc'] as $key => $value) {
				$bc->set('root', $key, $value);
			}
			foreach ($save['ba'] as $key => $value) {
				$ba->set($key, $value);
			}
		}
		$fm= new fileManagement();
		$fm->activate();
		break;
	case 'firmware':
		$ret = ($pt->updateFirmware() == true) ? 0 : 1;
		$pt->updateApps();
		break;
	case 'show_config':
		$ret = ($pt->showConfig() == true) ? 0 : 1;
		break;
	default:
		echo $usageMessage;
		return(1);
		break;
	}
}

return($ret);

?>
